#ifndef TUNNELIT_HELPER_H
#  define TUNNELIT_HELPER_H 1

#  ifdef HAVE_CONFIG_H
#    include "config.h"
#  endif /* HAVE_CONFIG_H */

#  ifdef HAVE_STDIO_H
#    include <stdio.h>
#  endif /* HAVE_STDIO_H */

#  ifdef DEBUG
#    undef NDEBUG
#    define DEBUG_LOG(y, ...) { fprintf(stderr, "%s:%i:%s(): %s: ", __FILE__, __LINE__, __func__, y); fprintf(stderr, __VA_ARGS__); fprintf(stderr, "\n"); }
#    define PERROR(x) { fprintf(stderr, "%s:%i:%s(): ", __FILE__, __LINE__, __func__); perror(x); }
#    define ERROR_LOG(...) DEBUG_LOG("error", __VA_ARGS__)
#    define WARNING_LOG(...) DEBUG_LOG("warning", __VA_ARGS__)
#  else
#    define NDEBUG 1
#    define DEBUG_LOG(y, ...) /**/
#    define PERROR(x) perror(x)
#    define ERROR_LOG(...) { fprintf(stderr, "error: "); fprintf(stderr, __VA_ARGS__); }
#    define WARNING_LOG(...) { fprintf(stderr, "warning: "); fprintf(stderr, __VA_ARGS__); }
#  endif /* DEBUG */
#endif /* TUNNELIT_HELPER_H */
